// Generated by CoffeeScript 1.6.3
var Event, Flow, Way, Ways,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

Event = require('happens');

Way = require('./way');

Flow = require('./flow');

Ways = (function(_super) {
  __extends(Ways, _super);

  Ways.prototype.mode = null;

  Ways.prototype.flow = null;

  Ways.prototype.routes = null;

  Ways.prototype.middlware = null;

  function Ways(mode) {
    this.mode = mode;
    this.routes = [];
    if (this.mode != null) {
      this.flow = new Flow(this);
    }
  }

  Ways.prototype.use = function(Middleware) {
    var _this = this;
    if (this.middleware != null) {
      return;
    }
    this.middleware = new Middleware;
    return this.middleware.on('url:change', function() {
      return _this._route(_this.middleware.pathname());
    });
  };

  Ways.prototype.get = function(pattern, runner, destroyer, dependency) {
    var route;
    route = new Way(pattern, runner, destroyer, dependency);
    this.routes.push(route);
    return route;
  };

  Ways.prototype.pathname = function() {
    var _ref;
    return (_ref = this.middleware) != null ? _ref.pathname() : void 0;
  };

  Ways.prototype._route = function(url) {
    var route, _i, _len, _ref;
    url = '/' + url.replace(/^[\/]+|[\/]+$/mg, '');
    _ref = this.routes;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      route = _ref[_i];
      if (route.matcher.test(url)) {
        return this._run(url, route);
      }
    }
    throw new Error("Route not found for url '" + url + "'");
  };

  Ways.prototype._run = function(url, route) {
    if (this.flow != null) {
      this.flow.run(url, route);
    } else {
      this.emit('url:change', url);
      route.run(url);
    }
    return route;
  };

  Ways.prototype.push = function(url, title, state) {
    if (this.middleware != null) {
      return this.middleware.push(url, title, state);
    } else {
      return this._route(url);
    }
  };

  Ways.prototype.replace = function(url, title, state, silent) {
    if (this.middleware != null) {
      return this.middleware.replace(url, title, state);
    }
  };

  return Ways;

})(Event);

module.exports = Ways;
